#include <descrip.h>

#define MAIL$_NOMOREREC 8314792
#define MAIL$_NOTEXIST 8290522
#define MAIL$_NOMOREMSG 8290386
#define MAIL$_NOSUCHUSR 8290346
#define MAIL$_USERSPEC 8290402
#define TEMPFILE_IN "sys$scratch:ptmail$temp_in.tmp"
#define TEMPFILE_OUT "sys$scratch:ptmail$temp_out.tmp"
#define TEMPPRINT "sys$scratch:ptmail$temp_print.tmp"
#define ALIASFILE "sys$login:ptmail.alias"
#define INITFILE "sys$login:ptmail.ini"
#define TEMPINIT "sys$scratch:ptmail$ini.tmp"
	/* True and false definitions */
#define TRUE	1
#define FALSE	0
#define YES     1
#define NO      0
        /* Different types returned by get_folder_name */
#define T_FILE   1
#define T_FOLDER 2 
#define T_NEWFOLDER 3
	/* Different ways to exit a folder, exit = save changes, quit = dont */
#define EXIT	1
#define QUIT    2
#define UPDATE  4
	/* Flags for a message */
#define M_UNSEL 1
#define M_SEL   2
#define M_DEL   4
#define M_MOVE  8
#define M_COPY  16
#define M_READ  32
	/* types of message to send out */
#define SEND	1
#define REPLY   2
#define FORWARD 3

#define setit(n, mask)          n |= mask
#define clearit(n, mask)        n &= ~mask

#define _MLEN(des)      des.dsc$w_length
#define _MPTR(des)      des.dsc$a_pointer

static  struct  dsc$descriptor_s
   _tmp_descr_1 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 },
   _tmp_descr_2 = { 0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0 };

#define DSC1(str) (_MLEN (_tmp_descr_1) = strlen (str),\
 _MPTR (_tmp_descr_1) = str, &_tmp_descr_1)
#define DSC2(str) (_MLEN (_tmp_descr_2) = strlen (str),\
 _MPTR (_tmp_descr_2) = str, &_tmp_descr_2)

#define vms_ok(x) ((x) & 1)

#define VMSFUNC unsigned int

typedef struct {
  unsigned short buflen;
  unsigned short code;
  char *bufadr;
  unsigned int *retlen;
} vms_item;

typedef struct {
  short buffer_length;
  short item_code;
  long buffer_address;
  long return_length_address;
} itemlist;

struct list {
  struct list *next;
  char *foldername;
  long message_count;
};

typedef struct {
  long deleted_bytes;
  long total_folders;
  long total_messages;
  long auto_purge;
  long cc_prompt;
  long copy_forward;
  long copy_reply;
  long copy_send;
  short new_messages;
  short waste_messages;
  char wastebasket[256];
  char result_spec[256];
  char editor[256];
  char forwarding[256];
  char form[256];
  char full_dir[256];
  char personal_name[256];
  char queue[256];
  char sub_dir[256];
  char username[256];
  char quote[256];
  char editini[256];
  char sigfile[256];
  int addsig;
  int novice;
} user_info;

struct m_descriptor {
  short length;
  char dtype;
  char class;
  char *pointer;
  char scale;
  char digits;
  char aflags;
  char dimct;
  long arsize;
  char *a0;
  long m1;
  long l1;
  long u1;
};

typedef struct {
  short len;
  short type;
  char *addr;
} s_desc;

typedef struct {
  struct msg_entry *prev;
  struct msg_entry *next;
  long id;
  long size;
  char date[256];
  char from[256];
  char reply[256];
  char subject[256];
  char dest[256];
  long flags;
} msg_entry;


typedef struct {
  struct alias_info *next;
  char alias[21];
  char trans[61];
} alias_info;

